"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request-promise");
const xml2js = require("xml2js");
// http://www.ecb.europa.eu/stats/policy_and_exchange_rates/euro_reference_exchange_rates/html/index.en.html
function fetch() {
    return __awaiter(this, void 0, void 0, function* () {
        const result = yield request('http://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml').promise();
        return new Promise((resolve, reject) => {
            xml2js.parseString(result, (err, data) => {
                if (err)
                    return reject(err);
                const time = data['gesmes:Envelope']['Cube'][0]['Cube'][0]['$']['time'];
                const rates = {};
                for (const item of data['gesmes:Envelope']['Cube'][0]['Cube'][0]['Cube']) {
                    const currency = item['$']['currency'];
                    const rate = parseFloat(item['$']['rate']);
                    rates[currency] = rate;
                }
                resolve({ time, rates });
            });
        });
    });
}
exports.fetch = fetch;
// CLI only when module is not require'd
if (require.main === module) {
    (() => __awaiter(this, void 0, void 0, function* () {
        const result = yield fetch();
        console.log(JSON.stringify(result, null, 2));
    }))().catch(() => { });
}
